local addonName, addon = ...

-- tables
local string = string
-- functions
local format = string.format
local GetAddOnMetadata = GetAddOnMetadata
-- constants
-- frames
-- libs
local LibStub = LibStub
local LibDBIcon = LibStub("LibDBIcon-1.0")

local minimapButtonName = "BrokerKeystonesMiniMapButton"

addon:RegisterCallback(addon.EVENT_BROKER_INITIALISED, function(_, broker)
    addon.db.minimap = addon.db.minimap or {}

    LibDBIcon:Register(minimapButtonName, broker, addon.db.minimap)
end)

function addon:HideMinimapButton()
    LibDBIcon:Hide(minimapButtonName)
    self.db.minimap.hide = true
    LibDBIcon:Refresh(minimapButtonName, self.db.minimap)
    addon:Print([[The minimap button has been hidden.  To show it again, type "/bk show".]])
end

function addon:ShowMinimapButton()
    LibDBIcon:Show(minimapButtonName)
    self.db.minimap.hide = nil
    LibDBIcon:Refresh(minimapButtonName, self.db.minimap)
    addon:Print([[The minimap button is now shown again.  To hide it, type "/bk hide".]])
end

function addon:ToggleMinimapButton()
    if self:IsMinimapButtonShown() then
        self:HideMinimapButton()
        return
    end

    self:ShowMinimapButton()
end

function addon:IsMinimapButtonShown()
    return not self.db.minimap or not self.db.minimap.hide -- or (not self.db.minimap.hide == true)
end

-- TODO: Move elsewhere
SLASH_BK1 = "/bk"
SLASH_BK2 = "/brokerkeystones"
SLASH_BK3 = "/broker_keystones"
SlashCmdList["BK"] = function(msg)
    if msg == "info" then
        addon:Print("%s, version %s", addonName, GetAddOnMetadata(addonName, "version"))
        return
    end

    if msg == "hide" then
        addon:HideMinimapButton()
        return
    end

    if msg == "show" then
        addon:ShowMinimapButton()
        return
    end

    addon:Print([[Available options are "info", "hide", "show"]], msg)
end
